## utox 0.3.2+git20150620.r1811-1~trusty+1+7.0trisquel1

=== Makefile ===
## OPTIONS ##
# set to anything else to disable them
DBUS = 1
V4LCONVERT = 1
FILTER_AUDIO = 1
UNITY = 0

DEPS = fontconfig freetype2 libtoxav libtoxcore
DEPS += openal vpx x11 xext xrender

ifeq ($(DBUS), 1)
    DEPS += dbus-1
endif

ifeq ($(V4LCONVERT), 1)
    DEPS += libv4lconvert
endif

ifeq ($(FILTER_AUDIO), 1)
    DEPS += filteraudio
endif

ifeq ($(UNITY), 1)
    DEPS += messaging-menu unity
endif

UNAME_S := $(shell uname -s)

CFLAGS += -g -Wall -Wshadow -pthread -std=gnu99
CFLAGS += $(shell pkg-config --cflags $(DEPS))
LDFLAGS = -pthread -lm
LDFLAGS += $(shell pkg-config --libs $(DEPS))
LDFLAGS += -lrt

CFLAGS += $(shell dpkg-buildflags --get CFLAGS)
LDFLAGS += $(shell dpkg-buildflags --get LDFLAGS)

ifneq ($(DBUS), 1)
    CFLAGS += -DNO_DBUS
endif

ifneq ($(V4LCONVERT), 1)
    CFLAGS += -DNO_V4LCONVERT
endif

ifeq ($(FILTER_AUDIO), 1)
    CFLAGS += -DAUDIO_FILTERING
endif

ifeq ($(UNITY), 1)
    CFLAGS += -DUNITY
endif

ifeq ($(UNAME_S), Linux)
    LDFLAGS += -lresolv -ldl
endif

DESTDIR ?=
PREFIX ?= /usr/local

SRC = $(wildcard *.c png/png.c)
OBJ = $(SRC:.c=.o)
GIT_V = $(shell git describe --abbrev=8 --dirty --always --tags)

all: utox

utox: $(OBJ)
	@echo "  LD    $@"
	@$(CC) $(CFLAGS) -o utox $(OBJ) $(LDFLAGS)

install: utox
	mkdir -p $(DESTDIR)$(PREFIX)/bin
	install -m 0755 utox $(DESTDIR)$(PREFIX)/bin/utox

	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/14x14/apps
	install -m 644 icons/utox-14x14.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/14x14/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/16x16/apps
	install -m 644 icons/utox-16x16.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/16x16/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/22x22/apps
	install -m 644 icons/utox-22x22.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/22x22/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/24x24/apps
	install -m 644 icons/utox-24x24.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/24x24/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/32x32/apps
	install -m 644 icons/utox-32x32.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/32x32/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/36x36/apps
	install -m 644 icons/utox-36x36.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/36x36/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/48x48/apps
	install -m 644 icons/utox-48x48.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/48x48/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/64x64/apps
	install -m 644 icons/utox-64x64.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/64x64/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/72x72/apps
	install -m 644 icons/utox-72x72.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/72x72/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/96x96/apps
	install -m 644 icons/utox-96x96.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/96x96/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/128x128/apps
	install -m 644 icons/utox-128x128.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/128x128/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/192x192/apps
	install -m 644 icons/utox-192x192.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/192x192/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/256x256/apps
	install -m 644 icons/utox-256x256.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/256x256/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/512x512/apps
	install -m 644 icons/utox-512x512.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/512x512/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/scalable/apps
	install -m 644 icons/utox.svg $(DESTDIR)$(PREFIX)/share/icons/hicolor/scalable/apps/utox.svg

	mkdir -p $(DESTDIR)$(PREFIX)/share/applications
	install -m 644 utox.desktop $(DESTDIR)$(PREFIX)/share/applications/utox.desktop
	if [ "$(UNITY)" -eq "1" ]; then echo "X-MessagingMenu-UsesChatSection=true" >> $(DESTDIR)$(PREFIX)/share/applications/utox.desktop; fi

	mkdir -p $(DESTDIR)$(PREFIX)/share/man/man1
	install -m 644 utox.1 $(DESTDIR)$(PREFIX)/share/man/man1/utox.1

main.o: xlib/main.c xlib/keysym2ucs.c

.c.o:
	@echo "  CC    $@"
	@$(CC) $(CFLAGS) -o $@ -c -DGIT_VERSION=\"$(GIT_V)\" $<

clean:
	rm -f utox *.o png/*.o

.PHONY: all clean

=== cocoa/Makefile ===
## OPTIONS ##
# set to anything else to disable them
COCOA = 1
FILTER_AUDIO = 1

CFLAGS ?= ""
LDFLAGS ?= ""
FRAMEWORKS = -framework AppKit -framework CoreGraphics -framework OpenAL -framework Foundation \
    -framework CoreText -framework CoreFoundation -framework AVFoundation \
    -framework CoreVideo -framework CoreMedia -framework OpenGL -framework QuartzCore \
    -lresolv
DEPS = libtoxcore libtoxav vpx libsodium

ifeq ($(FILTER_AUDIO), 1)
    DEPS += filteraudio
    CFLAGS += -DAUDIO_FILTERING
endif

CFLAGS += -g -Wall -Wshadow -Os
CFLAGS += $(shell pkg-config --cflags $(DEPS))
LDFLAGS += $(FRAMEWORKS)
LDFLAGS += -pthread -lm
LDFLAGS += $(shell pkg-config --libs $(DEPS))

DESTDIR ?=
PREFIX ?= /usr/local

SRC = $(wildcard *.c cocoa/*.m)
OBJ = $(SRC:=.o)
GIT_V = $(shell git describe --abbrev=8 --dirty --always --tags)
CFLAGS += -DGIT_VERSION=\"$(GIT_V)\"

all: utox

utox: $(OBJ)
	@echo "  LD    $@"
	@$(CC) $(CFLAGS) -o utox $(OBJ) $(LDFLAGS)

utox-static: $(OBJ)
	@echo "  SL    $@"
	$(CC) $(CFLAGS) -o utox-static $(OBJ) $(shell cocoa/find_static.sh $(DEPS)) $(FRAMEWORKS)

utox-MainMenu.nib:
	ibtool --compile $@ cocoa/MainMenu.xib

utox-Info.plist:
	sh cocoa/make_info_plist.sh cocoa/Info.plist $@

utox.icns:
	iconutil --convert icns cocoa/utox.iconset -o ./utox.icns

uTox.app: utox utox-Info.plist utox-MainMenu.nib utox.icns
	mkdir -p uTox.app/Contents/MacOS
	mkdir -p uTox.app/Contents/Resources
	install -m 755 utox uTox.app/Contents/MacOS/utox
	install -m 644 utox-Info.plist uTox.app/Contents/Info.plist
	install -m 644 utox.icns uTox.app/Contents/Resources/uTox.icns
	install -m 644 utox-MainMenu.nib uTox.app/Contents/Resources/MainMenu.nib

uTox.dmg: utox-static uTox.app
	sh cocoa/make_dmg.sh

%.m.o: %.m
	@echo "  OBJC  $@"
	@$(CC) -xobjective-c $(CFLAGS) -o $@ -c $<

%.c.o: %.c
	@echo "  CC    $@"
	@$(CC) -xobjective-c $(CFLAGS) -o $@ -c $<

clean:
	rm -f utox utox-Info.plist utox-MainMenu.nib cocoa/*.o *.o .utox_info_plist.* utox-static uTox.dmg
	rm -rf uTox.app utox_dmg.*

print-%:
	@echo $($*)

.PHONY: all clean

=== .pc/0001-hardening-flags.patch/Makefile ===
## OPTIONS ##
# set to anything else to disable them
DBUS = 1
V4LCONVERT = 1
FILTER_AUDIO = 1
UNITY = 0

DEPS = fontconfig freetype2 libtoxav libtoxcore
DEPS += openal vpx x11 xext xrender

ifeq ($(DBUS), 1)
    DEPS += dbus-1
endif

ifeq ($(V4LCONVERT), 1)
    DEPS += libv4lconvert
endif

ifeq ($(FILTER_AUDIO), 1)
    DEPS += filteraudio
endif

ifeq ($(UNITY), 1)
    DEPS += messaging-menu unity
endif

UNAME_S := $(shell uname -s)

CFLAGS += -g -Wall -Wshadow -pthread -std=gnu99
CFLAGS += $(shell pkg-config --cflags $(DEPS))
LDFLAGS = -pthread -lm
LDFLAGS += $(shell pkg-config --libs $(DEPS))

ifneq ($(DBUS), 1)
    CFLAGS += -DNO_DBUS
endif

ifneq ($(V4LCONVERT), 1)
    CFLAGS += -DNO_V4LCONVERT
endif

ifeq ($(FILTER_AUDIO), 1)
    CFLAGS += -DAUDIO_FILTERING
endif

ifeq ($(UNITY), 1)
    CFLAGS += -DUNITY
endif

ifeq ($(UNAME_S), Linux)
    LDFLAGS += -lresolv -ldl
endif

DESTDIR ?=
PREFIX ?= /usr/local

SRC = $(wildcard *.c png/png.c)
OBJ = $(SRC:.c=.o)
GIT_V = $(shell git describe --abbrev=8 --dirty --always --tags)

all: utox

utox: $(OBJ)
	@echo "  LD    $@"
	@$(CC) $(CFLAGS) -o utox $(OBJ) $(LDFLAGS)

install: utox
	mkdir -p $(DESTDIR)$(PREFIX)/bin
	install -m 0755 utox $(DESTDIR)$(PREFIX)/bin/utox

	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/14x14/apps
	install -m 644 icons/utox-14x14.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/14x14/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/16x16/apps
	install -m 644 icons/utox-16x16.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/16x16/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/22x22/apps
	install -m 644 icons/utox-22x22.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/22x22/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/24x24/apps
	install -m 644 icons/utox-24x24.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/24x24/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/32x32/apps
	install -m 644 icons/utox-32x32.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/32x32/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/36x36/apps
	install -m 644 icons/utox-36x36.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/36x36/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/48x48/apps
	install -m 644 icons/utox-48x48.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/48x48/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/64x64/apps
	install -m 644 icons/utox-64x64.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/64x64/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/72x72/apps
	install -m 644 icons/utox-72x72.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/72x72/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/96x96/apps
	install -m 644 icons/utox-96x96.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/96x96/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/128x128/apps
	install -m 644 icons/utox-128x128.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/128x128/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/192x192/apps
	install -m 644 icons/utox-192x192.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/192x192/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/256x256/apps
	install -m 644 icons/utox-256x256.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/256x256/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/512x512/apps
	install -m 644 icons/utox-512x512.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/512x512/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/scalable/apps
	install -m 644 icons/utox.svg $(DESTDIR)$(PREFIX)/share/icons/hicolor/scalable/apps/utox.svg

	mkdir -p $(DESTDIR)$(PREFIX)/share/applications
	install -m 644 utox.desktop $(DESTDIR)$(PREFIX)/share/applications/utox.desktop
	if [ "$(UNITY)" -eq "1" ]; then echo "X-MessagingMenu-UsesChatSection=true" >> $(DESTDIR)$(PREFIX)/share/applications/utox.desktop; fi

	mkdir -p $(DESTDIR)$(PREFIX)/share/man/man1
	install -m 644 utox.1 $(DESTDIR)$(PREFIX)/share/man/man1/utox.1

main.o: xlib/main.c xlib/keysym2ucs.c

.c.o:
	@echo "  CC    $@"
	@$(CC) $(CFLAGS) -o $@ -c -DGIT_VERSION=\"$(GIT_V)\" $<

clean:
	rm -f utox *.o png/*.o

.PHONY: all clean

=== .pc/0002-fix-RaspberryPi-FTBFS.patch/Makefile ===
## OPTIONS ##
# set to anything else to disable them
DBUS = 1
V4LCONVERT = 1
FILTER_AUDIO = 1
UNITY = 0

DEPS = fontconfig freetype2 libtoxav libtoxcore
DEPS += openal vpx x11 xext xrender

ifeq ($(DBUS), 1)
    DEPS += dbus-1
endif

ifeq ($(V4LCONVERT), 1)
    DEPS += libv4lconvert
endif

ifeq ($(FILTER_AUDIO), 1)
    DEPS += filteraudio
endif

ifeq ($(UNITY), 1)
    DEPS += messaging-menu unity
endif

UNAME_S := $(shell uname -s)

CFLAGS += -g -Wall -Wshadow -pthread -std=gnu99
CFLAGS += $(shell pkg-config --cflags $(DEPS))
LDFLAGS = -pthread -lm
LDFLAGS += $(shell pkg-config --libs $(DEPS))

CFLAGS += $(shell dpkg-buildflags --get CFLAGS)
LDFLAGS += $(shell dpkg-buildflags --get LDFLAGS)

ifneq ($(DBUS), 1)
    CFLAGS += -DNO_DBUS
endif

ifneq ($(V4LCONVERT), 1)
    CFLAGS += -DNO_V4LCONVERT
endif

ifeq ($(FILTER_AUDIO), 1)
    CFLAGS += -DAUDIO_FILTERING
endif

ifeq ($(UNITY), 1)
    CFLAGS += -DUNITY
endif

ifeq ($(UNAME_S), Linux)
    LDFLAGS += -lresolv -ldl
endif

DESTDIR ?=
PREFIX ?= /usr/local

SRC = $(wildcard *.c png/png.c)
OBJ = $(SRC:.c=.o)
GIT_V = $(shell git describe --abbrev=8 --dirty --always --tags)

all: utox

utox: $(OBJ)
	@echo "  LD    $@"
	@$(CC) $(CFLAGS) -o utox $(OBJ) $(LDFLAGS)

install: utox
	mkdir -p $(DESTDIR)$(PREFIX)/bin
	install -m 0755 utox $(DESTDIR)$(PREFIX)/bin/utox

	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/14x14/apps
	install -m 644 icons/utox-14x14.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/14x14/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/16x16/apps
	install -m 644 icons/utox-16x16.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/16x16/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/22x22/apps
	install -m 644 icons/utox-22x22.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/22x22/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/24x24/apps
	install -m 644 icons/utox-24x24.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/24x24/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/32x32/apps
	install -m 644 icons/utox-32x32.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/32x32/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/36x36/apps
	install -m 644 icons/utox-36x36.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/36x36/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/48x48/apps
	install -m 644 icons/utox-48x48.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/48x48/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/64x64/apps
	install -m 644 icons/utox-64x64.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/64x64/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/72x72/apps
	install -m 644 icons/utox-72x72.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/72x72/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/96x96/apps
	install -m 644 icons/utox-96x96.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/96x96/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/128x128/apps
	install -m 644 icons/utox-128x128.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/128x128/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/192x192/apps
	install -m 644 icons/utox-192x192.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/192x192/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/256x256/apps
	install -m 644 icons/utox-256x256.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/256x256/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/512x512/apps
	install -m 644 icons/utox-512x512.png $(DESTDIR)$(PREFIX)/share/icons/hicolor/512x512/apps/utox.png
	mkdir -p $(DESTDIR)$(PREFIX)/share/icons/hicolor/scalable/apps
	install -m 644 icons/utox.svg $(DESTDIR)$(PREFIX)/share/icons/hicolor/scalable/apps/utox.svg

	mkdir -p $(DESTDIR)$(PREFIX)/share/applications
	install -m 644 utox.desktop $(DESTDIR)$(PREFIX)/share/applications/utox.desktop
	if [ "$(UNITY)" -eq "1" ]; then echo "X-MessagingMenu-UsesChatSection=true" >> $(DESTDIR)$(PREFIX)/share/applications/utox.desktop; fi

	mkdir -p $(DESTDIR)$(PREFIX)/share/man/man1
	install -m 644 utox.1 $(DESTDIR)$(PREFIX)/share/man/man1/utox.1

main.o: xlib/main.c xlib/keysym2ucs.c

.c.o:
	@echo "  CC    $@"
	@$(CC) $(CFLAGS) -o $@ -c -DGIT_VERSION=\"$(GIT_V)\" $<

clean:
	rm -f utox *.o png/*.o

.PHONY: all clean

=== debian/changelog ===
utox (0.3.2+git20150620.r1811-1~trusty+1+7.0trisquel1) belenos; urgency=medium

  * Bring Tox to Trisquel from PPA

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Fri, 26 Jun 2015 10:39:00 +0000

utox (0.3.2+git20150620.r1811-1~trusty+1) trusty; urgency=medium

  * Building for Trusty

 -- Kill Your TV <killyourtv@i2pmail.org>  Thu, 25 Jun 2015 17:58:43 +0000

utox (0.3.2+git20150620.r1811-1) unstable; urgency=medium

  [ flan ]
  * add ftoutfo description to the man page
  * fix some consistency issues in the man page

  [ GrayHatter ]
  * indent for code folding
  * UI refactor part 1
  * sidebar now works, just don't click on anything
  * The tested settings work, on to users and groups
  * Mass rename from sitem -> selected_item
  * finished rewrite of selection of pages for ui-refactor
  * set the default view to be settings

  [ Gregory Mullen (grayhatter) ]
  * fix some linux errors
  * HOTFIX accepting friend requests
  * HOTFIX force clear of friends request page, to avoid a libc free segfault

  [ flan ]
  * add alias info to the man page

  [ Kill Your TV ]
  * New usptream git snapshpt

 -- Kill Your TV <killyourtv@i2pmail.org>  Mon, 22 Jun 2015 22:50:30 +0000

utox (0.3+git20150605.r1763-2) unstable; urgency=medium

  [ GrayHatter ]
  * Added new slash commands function
  * added set alias function
  * added commands.h to main.h
  * use alias if available
  * use new commands function in edit_msg_onenter

  [ Gregory Mullen (grayhatter) ]
  * fixed length issue, and sending erronous commands

  [ GrayHatter ]
  * added struct to save data to a file

  [ Gregory Mullen (grayhatter) ]
  * restore alias names
  * added writing metadata to file
  * added write_raw funciton

  [ Simon Grim ]
  * update of ru localization file
  * localized titles for gtk dialogs
  * delete Zenburn theme definition from ru localization file since it's a
    proper noun which shouldn't be translated

  [ v2e ]
  * Update ua.h

  [ flan ]
  * reorder items in the context menu

  [ Gregory Mullen (grayhatter) ]
  * Upgaded some strings, + v tick

  [ stal ]
  * datapath() should make its dir recursively

  [ Ansa89 ]
  * Italian translation: update

  [ sfan5 ]
  * Update German translations

  [ GrayHatter ]
  * closes #1061

  [ irungentoo ]
  * printf -> debug

  [ flan ]
  * fix comment typos

  [ v2e ]
  * Update ua.h

  [ GrayHatter ]
  * comment debug for backlog messages

  [ Kill Your TV ]
  * New upstream git snapshot

 -- Kill Your TV <killyourtv@i2pmail.org>  Sat, 13 Jun 2015 15:02:04 +0000

utox (0.3+git20150605.r1763-1) unstable; urgency=medium

  [ Gregory Mullen (grayhatter) ]
  * add new strings for settings layout changes
  * added in network settings button
  * added Other settings, network settings, and UI setting tabs
  * ui tweaks care of @tsudoko

  [ GrayHatter ]
  * Makefile patch from stal
  * added av settings tab
  * Fix different scroll highights for the settings
  * make the settings tabs look like tabs
  * closes #542
  * revision tick v0.3.0 to v0.3.1

  [ Gregory Mullen (grayhatter) ]
  * switch to the correct settings page with name/status click
  * move filer audio in a bit
  * fix moving lines
  * fixed button size
  * fixed line color and positioning
  * shrink header for just settings page
  * change color on mouse over
  * reverte unneeded struct val addition
  * use main text, not menu text
  * revert debugging shortcut
  * rename user settings to profile

  [ ovitei ]
  * Updated norwegian translation to match the english one
  * Updated Norwegian translations

  [ GrimKriegor ]
  * Beginning PT_pt localization.
  * PT_pt localization complete. Testing.
  * Added and tested pt_PT locale.
  * Small fixes in the pt_PT locale.

  [ Ansa89 ]
  * Italian translation: update

  [ sfan5 ]
  * Update German translation

  [ flan ]
  * fix makefile var expansion

  [ What colour is Umi's hair anyway? ]
  * Fix bug

  [ Kill Your TV ]
  * New upstream git snapshot

 -- Kill Your TV <killyourtv@i2pmail.org>  Sun, 07 Jun 2015 00:38:05 +0000

utox (0.3+git20150530.r1725-1) unstable; urgency=medium

  [ Thomas Ross ]
  * Add context menu button for changing the topic of group chats (Fixes #850)
  * Fix line endings

  [ stal ]
  * fix API change

  [ irungentoo ]
  * Fixed last pr.
  * Fixed segfault.
  * ctrl-c on messages now copies like the default.

  [ Ansa89 ]
  * Italian translation: update

  [ LittleVulpix ]
  * Fix minor typo

  [ irungentoo ]
  * Don't draw offscreen toxt messages.

  [ Kill Your TV ]
  * New upstream git snapshot

 -- Kill Your TV <killyourtv@i2pmail.org>  Sun, 31 May 2015 11:47:09 +0000

utox (0.3-1) unstable; urgency=medium

  [ irungentoo ]
  * Change yuv420tobgr in preparation for new a/v api.
  * Preparation for the new A/V api.

  [ Kill Your TV ]
  * New upstream git snapshot

 -- Kill Your TV <killyourtv@i2pmail.org>  Tue, 26 May 2015 20:05:47 +0000

utox (0.2.s+20150524.r1706-1) unstable; urgency=medium

  [ stal ]
  * disable some non-working things
  * fix prompt string in file picker
  * differentiate between real urls and file paths

  [ SmoothDude ]
  * Added option to toggle send of typing notifications.
  * Forget to set setting for typing notifications, when save is loaded

  [ irungentoo ]
  * uTox now works with latest VAD filter_audio.

  [ Mate Bene ]
  * Auto startup feature implemented.

  [ Gregory Mullen (grayhatter) ]
  * don't resize file on disk for file transfers
  * subversion tick, rev reset

  [ Ansa89 ]
  * Italian translation: update

  [ stal ]
  * Fix desktop video capture
  * fix various IroncladWIndow nits
  * end call, preview when closing ironclad window
  * Fix desktop capture for real.
  * Code cleanups and fixed bug.
  * fix desktop capture on retina display
  * implement resize_file
  * rudimentary rich input support
  * more IME support

  [ Mate Bene ]
  * Auto startup feature implemented.

  [ GrayHatter ]
  * added start-on-boot to xlib


=== debian/control ===
Source: utox
Section: net
Priority: optional
Maintainer: Kill Your TV <killyourtv@i2pmail.org>
Build-Depends: debhelper (>= 9),
 dpkg-dev (>= 1.16.1~),
 libdbus-1-dev,
 libfontconfig1-dev,
 libfreetype6-dev,
 libopenal-dev,
 libtoxav-dev (>= 0.0.0+20141129.r2982),
 libtoxcore-dev (>= 0.0.0+20150323.r3271),
 libtoxdns-dev (>= 0.0.0+20140928.1),
 libtoxencryptsave-dev (>= 0.0.0+20150323.r3271),
 libfilteraudio-dev (>= 0.0.0+git20150127),
 libv4l-dev,
 libxext-dev,
 libxrender-dev,
 dh-apparmor
Standards-Version: 3.9.6
Homepage: https://github.com/notsecure/uTox
Vcs-Git: git://killyourtv.i2p/git/uTox.git
Vcs-Browser: http://killyourtv.i2p/gitweb/?p=uTox.git;a=shortlog

Package: utox
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: apparmor
Description: lightweight gui Tox client
 This client is at the early stages of development but it currently supports
 some of the most important features, such as file transfers, A/V, group chats,
 and DNS Discovery

Package: utox-dbg
Architecture: any
Priority: extra
Section: debug
Depends: ${shlibs:Depends}, ${misc:Depends}, utox (= ${binary:Version}),
 libtoxdns-dbg,
 libtoxencryptsave-dbg,
 libtoxcore-dbg,
 libtoxav-dbg
Description: lightweight gui Tox client
 This client is at the early stages of development but it currently supports
 some of the most important features, such as file transfers, A/V, group chats,
 and DNS Discovery

=== debian/rules ===
#!/usr/bin/make -f
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

%:
	dh $@  --parallel

override_dh_auto_build:
	$(MAKE) PREFIX=/usr DESTDIR=$(CURDIR)/debian/utox
	dh_auto_build

override_dh_auto_install:
	$(MAKE) install PREFIX=/usr DESTDIR=$(CURDIR)/debian/utox

override_dh_install:
	dh_install --fail-missing
	cp debian/apparmor/usr.bin.utox debian/utox/etc/apparmor.d
	dh_apparmor --profile=usr.bin.utox -putox

override_dh_strip:
	dh_strip --dbg-package=utox-dbg

## utox 0.17.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)
set(CMAKE_OSX_DEPLOYMENT_TARGET 10.6 CACHE STRING "Minimum OS X deployment version")
project(uTox LANGUAGES C)

#####################
## Project Metadata #
#####################

set(PROJECT_VERSION_MAJOR "0")
set(PROJECT_VERSION_MINOR "17")
set(PROJECT_VERSION_PATCH "0")
set(PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")

set(PROJECT_COPYRIGHT "Copyleft 2018 uTox contributors. Some rights reserved.")

execute_process(COMMAND date +%Y OUTPUT_VARIABLE BUILD_YEAR OUTPUT_STRIP_TRAILING_WHITESPACE)
execute_process(COMMAND date +%B OUTPUT_VARIABLE BUILD_MONTH OUTPUT_STRIP_TRAILING_WHITESPACE)

########################
# Set helper-variables #
########################

# OS
if(CYGWIN)
    # Cygwin thinks it's actually Linux.
    set(WIN32 TRUE)
    set(UNIX FALSE)
endif()

if(WIN32)
    set(WINDOWS TRUE)
elseif(APPLE)
    if(CMAKE_SYSTEM_NAME MATCHES ".*MacOS.*")
        set(MACOSX TRUE)
    endif()
elseif(UNIX)
    if(CMAKE_SYSTEM_NAME MATCHES ".*Linux")
        set(LINUX TRUE)
    elseif(CMAKE_SYSTEM_NAME MATCHES "kOpenBSD.*|OpenBSD.*")
        set(OPENBSD TRUE)
    elseif(CMAKE_SYSTEM_NAME MATCHES "kNetBSD.*|NetBSD.*")
        set(NETBSD TRUE)
    elseif(CMAKE_SYSTEM_NAME MATCHES "kFreeBSD.*|FreeBSD")
        set(FREEBSD TRUE)
    endif()
endif()

# 32 or 64 bit
if(CMAKE_SIZEOF_VOID_P EQUAL 8)
  set(ARCH_64 TRUE)
else()
  set(ARCH_64 FALSE)
endif()



#############################
# System-dependent defaults #
#############################

# Windows only compiles statically.
if (WINDOWS)
    set(STATIC_DEFAULT ON)
else()
    set(STATIC_DEFAULT OFF)
endif()

# Disable ASAN for macOS due to "AddressSanitizer: odr-violation: global". see #957
# Windows doesn't compile with asan enabled.
if (APPLE OR WINDOWS)
    set(ASAN_DEFAULT OFF)
else()
    set(ASAN_DEFAULT ON)
endif()

# ASAN causes uTox to be slower so do no use it for release builds
if (CMAKE_BUILD_TYPE MATCHES "Release")
   set(ASAN_DEFAULT OFF)
endif()

###########
# Options #
###########

option(UTOX_STATIC        "Link uTox statically"                                 ${STATIC_DEFAULT} )
option(TOXCORE_STATIC     "Build uTox with the static version of Toxcore"        ${STATIC_DEFAULT} )
option(ENABLE_ASAN        "Enable Address Sanitizer on debug builds"               ${ASAN_DEFAULT} )
option(ENABLE_TESTS       "Whether to build test binaries (currently linux only)"               OFF)
option(ENABLE_WERROR      "Error on Warning, whether to put -Werror flag to the compiler"       OFF)
option(ENABLE_FILTERAUDIO "Enable Filter Audio"                                                 ON )
option(ENABLE_AUTOUPDATE  "Enable Auto-updater"                                                 OFF)
option(ENABLE_LTO         "Enable link time optimizations"                                      ON )


#################################
# Include toolchain if required #
#################################

if(WINDOWS AND NOT CROSS_COMPILING)
    include(cmake/win.cmake)

    if(ARCH_64)
        # Helping Cygwin out again..
        set(WIN64 TRUE)
    endif()
elseif(FREEBSD)
    include(cmake/toolchain-freebsd.cmake)
elseif(OPENBSD OR NETBSD)
    include(cmake/toolchain-openbsd.cmake)
elseif(APPLE)
    include(cmake/macOS.cmake)
endif()


#######################################################################
# CMake Settings
#######################################################################
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/")

# make version available in C files
configure_file(${uTox_SOURCE_DIR}/src/branding.h.in
               ${uTox_SOURCE_DIR}/src/branding.h)
configure_file(${uTox_SOURCE_DIR}/src/cocoa/Info.plist.in
               ${uTox_SOURCE_DIR}/src/cocoa/Info.plist)
configure_file(${uTox_SOURCE_DIR}/src/android/AndroidManifest.xml.in
               ${uTox_SOURCE_DIR}/src/android/AndroidManifest.xml)
configure_file(${uTox_SOURCE_DIR}/src/utox.1.in
               ${uTox_SOURCE_DIR}/src/utox.1)

if(${CMAKE_BUILD_TYPE} MATCHES Debug)
    execute_process(COMMAND git describe --abbrev=8 --dirty --always --tags
                    OUTPUT_VARIABLE GIT_VERSION)
    string(REPLACE "\n" " " GIT_VERSION ${GIT_VERSION})
endif()

#######################################################################
# C compiler flags
#######################################################################

set(CMAKE_C_STANDARD 11) # this requires at least cmake 3.1

include(CheckCCompilerFlag)

# add compiler flag for all build types
function(add_cflag flag)
    string(REGEX REPLACE "[^a-zA-Z0-9_]" "_" var ${flag})
    if(NOT DEFINED HAVE_C${var})
        message(STATUS "checking for C compiler flag: ${flag}")
    endif()
    set(CMAKE_REQUIRED_QUIET TRUE)

    check_c_compiler_flag("${flag}" HAVE_C${var} QUIET)
    if(HAVE_C${var})
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${flag}" PARENT_SCOPE)
    else()
        message(STATUS "Warning: Can't find flag ${flag}")
    endif()
endfunction()

# Grab environment CFLAGS.
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} $ENV{CFLAGS}")

# Warn on non-ISO C.
#add_cflag("-pedantic") # throws a lot of warning, quite sure we do not want this at current state.
## Add all warning flags we can.
add_cflag("-Wall")
add_cflag("-Wextra")
add_cflag("-Wpointer-arith")
add_cflag("-Wimplicit-fallthrough=5")

## Warnings we don't tolerate
add_cflag("-Werror=implicit-function-declaration")

## Warnings we don't care about
add_cflag("-Wformat=0")
add_cflag("-Wno-misleading-indentation")

## Everything Else
add_cflag("-fno-strict-aliasing")
add_cflag("-fPIC")

## Optimization Flags

# Fix GNU stack
if(CMAKE_C_COMPILER_ID MATCHES "GNU")
    # Have ld strip the symbols from Release and MinSizeRel build types.
    set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -Os")
    set(CMAKE_C_FLAGS_MINSIZEREL "${CMAKE_C_FLAGS_MINSIZEREL} -Os -s")

    if(LINUX)
        # enable Link Time Optimization on gcc (linux only currently)
        # TODO someone should figure out how this works on windows, or we need to have gitlab-ci for GCC
        if(ENABLE_LTO)
            ## -flto is a flag that needs to exist at link time as well,
            #  so we use some hacky save/restore to help cmake.
            set(SAVE_CMAKE_REQUIRED_LIBRARIES "${CMAKE_REQUIRED_LIBRARIES}")
            set(CMAKE_REQUIRED_LIBRARIES "-flto")
            add_cflag("-flto")
            set(CMAKE_REQUIRED_LIBRARIES "${SAVE_CMAKE_REQUIRED_LIBRARIES}")
        endif()

        set(CMAKE_AR "gcc-ar")
        set(CMAKE_RANLIB "gcc-ranlib")

        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,noexecstack")
    endif()
elseif(CMAKE_C_COMPILER_ID MATCHES "Clang")
    # Disable warning for `= { 0 }` in Clang.
    # Remove once they've resolved https://bugs.llvm.org//show_bug.cgi?id=21689
    add_cflag("-Wno-missing-field-initializers")

    # Enable Link Time Optimization on Clang
    if(ENABLE_LTO)
        ## -flto is a flag that needs to exist at link time as well,
        #  so we use some hacky save/restore to help cmake.
        set(SAVE_CMAKE_REQUIRED_LIBRARIES "${CMAKE_REQUIRED_LIBRARIES}")
        set(CMAKE_REQUIRED_LIBRARIES "-flto")
        add_cflag("-flto")
        set(CMAKE_REQUIRED_LIBRARIES "${SAVE_CMAKE_REQUIRED_LIBRARIES}")
    endif()

    # Have ld strip the symbols from Release and MinSizeRel build types. (-Oz is clang specific)
    set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -Os")
    set(CMAKE_C_FLAGS_MINSIZEREL "${CMAKE_C_FLAGS_MINSIZEREL} -Oz -s")

    if(NOT ENABLE_ASAN)
        if(NOT APPLE)
            add_cflag("-fsanitize=safe-stack")
        endif()
    endif()
else()
    message(STATUS "Unknown compiler name: You may have to set up your compiler flags yourself.")
endif()

# set define for GIT_VERSION
if(GIT_VERSION)
    add_cflag("-DGIT_VERSION='\"${GIT_VERSION}\"'")
endif()


#######################################################################
# Build options
#######################################################################

# https://github.com/google/sanitizers/wiki/AddressSanitizer
if (ENABLE_ASAN)
    set(SAVE_CMAKE_REQUIRED_LIBRARIES "${CMAKE_REQUIRED_LIBRARIES}")
    set(CMAKE_REQUIRED_LIBRARIES "-fsanitize=address")
    add_cflag("-fsanitize=address")
    add_cflag("-fno-omit-frame-pointer")
    set(CMAKE_REQUIRED_LIBRARIES "${SAVE_CMAKE_REQUIRED_LIBRARIES}")
endif()

if(ENABLE_WERROR)
    add_cflag("-Werror")
endif()

if(UTOX_STATIC)
    if(UNIX)
        add_cflag("-Wl -Bstatic -lopus -lopenal -lfilteraudio -Bdynamic -lrt -lm -lpthread -ldl")
    else()
        add_cflag("-static")
    endif()
endif()

if(ENABLE_AUTOUPDATE)
    add_cflag("-DENABLE_AUTOUPDATE=1")
endif()

if(ENABLE_FILTERAUDIO)
    add_cflag("-DAUDIO_FILTERING=1")
endif()

find_package(libtox REQUIRED)
include_directories(${LIBTOX_INCLUDE_DIRS})

find_package(libsodium REQUIRED)
include_directories(${LIBSODIUM_INCLUDE_DIRS})
set(LIBRARIES ${LIBRARIES} ${LIBSODIUM_LIBRARIES})

include_directories(SYSTEM third-party/stb)
include_directories(SYSTEM third-party/minini/dev)
include_directories(SYSTEM third-party/qrcodegen/c)

# Protip, you must use a different directory for each build target...
# -DMAKE_TOOLCHAIN_FILE has no effect unless the target directory is empty
# 1.5 hours to learn this...
if(WIN32)
    if (CMAKE_BUILD_TYPE STREQUAL "Release" OR CMAKE_BUILD_TYPE STREQUAL "MinSizeRel")
        set(GUI_TYPE WIN32)
    endif()

    link_directories(${CMAKE_PREFIX_PATH}/lib)

    # Windows icons
    enable_language(RC)
    set(WINDOWS_ICON src/windows/utox.rc)

    add_subdirectory(src/windows)
elseif(APPLE)
    set(GUI_TYPE MACOSX_BUNDLE)

    add_definitions("-x objective-c")
    add_subdirectory(src/cocoa)
elseif(UNIX)
    add_subdirectory(src/xlib)

    if(LINUX)
        # Required for v4l (at least in the Linux static builds on Jenkins)
        set(LIBRARIES ${LIBRARIES} "rt")
    endif()
endif()

# include utoxLAYOUT
add_subdirectory(src/layout)
# include utoxUI
add_subdirectory(src/ui)
# include utoxAV
add_subdirectory(src/av)

#######################################################################
# :: uTox main
#######################################################################
add_executable(utox ${GUI_TYPE}
    src/avatar.c
    src/chatlog.c
    src/chrono.c
    src/command_funcs.c
    src/commands.c
    src/devices.c
    src/file_transfers.c
    src/filesys.c
    src/flist.c
    src/friend.c
    src/groups.c
    src/inline_video.c
    src/logging.c
    src/main.c
    src/messages.c
    src/notify.c
    src/qr.c
    src/screen_grab.c
    src/self.c
    src/settings.c
    src/sized_string.h
    src/stb.c
    src/text.c
    src/theme.c
    src/tox.c
    src/tox_callbacks.c
    src/ui.c
    src/ui_i18n.c
    src/updater.c
    src/utox.c
    src/window.c
    third-party/minini/dev/minIni.c
    third-party/qrcodegen/c/qrcodegen.c

    ${WINDOWS_ICON}
    ${APPLE_FILES}
)

target_link_libraries(utox
    utoxAV
    utoxNATIVE
    utoxUI
    ${LIBTOX_LIBRARIES}
    ${LIBRARIES}
    vpx
    pthread
    m
)

set_property(TARGET utox PROPERTY C_STANDARD 11)

if(APPLE)
    set_target_properties(utox PROPERTIES MACOSX_BUNDLE_INFO_PLIST "${uTox_SOURCE_DIR}/src/cocoa/Info.plist")
    # check that the app is valid and when the app is static
    # also check that it does not depend on external libs (system libs excepted)
    install(CODE "include(BundleUtilities)
        verify_app(${CMAKE_BINARY_DIR}/utox.app)
        if(UTOX_STATIC OR TOXCORE_STATIC)
            verify_bundle_prerequisites(${CMAKE_BINARY_DIR}/utox.app RETURN_VAR INFO_VAR)
        endif()"
    )
    # needed for packaging, so that CPack can find the app
    install(TARGETS utox DESTINATION .)
    # install App
    install(TARGETS utox DESTINATION /Applications)
elseif(UNIX)
    install(TARGETS utox
        RUNTIME DESTINATION "bin"
        )
endif()

# packaging
include(CPack)

###########
# Testing #
###########

if(ENABLE_TESTS)
  if(UNIX)

=== tests/CMakeLists.txt ===
project(utoxTESTS LANGUAGES C)
include(CTest)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/")

find_package(Check REQUIRED)

function(make_test name)
    add_executable(test_${name} test_${name}.c)
    set_target_properties(test_${name} PROPERTIES COMPILE_FLAGS "-Wno-unused-parameter")
    target_link_libraries(test_${name} utox-test-mock ${CHECK_LIBRARIES})
    add_test(NAME test_${name} COMMAND test_${name})
endfunction()

configure_file(${utoxTESTS_SOURCE_DIR}/run_tests.sh
               ${uTox_BINARY_DIR}/run_tests.sh)

#
# generic testing defines
#
include_directories("../src")

add_library(utox-test-mock
            mock/mock_filesys.c
            mock/mock_settings.c
            mock/mock_logging.c
            mock/mock_threads.c
            mock/mock_system_calls.c
)
set_target_properties(utox-test-mock PROPERTIES COMPILE_FLAGS "-Wno-unused-parameter")
target_link_libraries(utox-test-mock pthread)

#
# tests
#
# TODO add a cmake macro for adding tests, this will be too verbose if we add more.
make_test(chatlog)

if(ENABLE_AUTOUPDATE)
  make_test(updater)
      target_link_libraries(test_updater sodium)
endif()

make_test(chrono)

=== src/av/CMakeLists.txt ===
project(utoxAV LANGUAGES C)

add_library(utoxAV STATIC
    utox_av.c
    audio.c
    video.c
    filter_audio.c
    )

if(WIN32)
    target_link_libraries(utoxAV OpenAL32) # Windows needs to be linked against OpenAL32
elseif(APPLE)
    find_package(libopus REQUIRED)
    include_directories(${LIBOPUS_INCLUDE_DIRS})
    target_link_libraries(utoxAV ${LIBOPUS_LIBRARIES}) # Link OSX against opus
else()
    # Both openal and opus are required for the static Linux builds on Jenkins.
    find_package(libopus REQUIRED)
    include_directories(${LIBOPUS_INCLUDE_DIRS})
    target_link_libraries(utoxAV ${LIBOPUS_LIBRARIES})
    target_link_libraries(utoxAV openal)
endif()

if(ENABLE_FILTERAUDIO)
    find_package(libfilteraudio REQUIRED)
    include_directories(${LIBFILTERAUDIO_INCLUDE_DIRS})
    target_link_libraries(utoxAV ${LIBFILTERAUDIO_LIBRARIES})
endif()

=== src/cocoa/CMakeLists.txt ===
project(utoxNATIVE LANGUAGES C)

add_library(utoxNATIVE STATIC
    ../posix/filesys.c

    cursor.h
    drawing.m
    grabdesktop.m
    interaction.m
    main.h
    main.m
    MainMenu.xib
    objc_main.h
    video.m

    window.c
    )

target_link_libraries(utoxNATIVE
    "-framework AppKit"
    "-framework ApplicationServices"
    "-framework AVFoundation"
    "-framework Cocoa"
    "-framework CoreData"
    "-framework CoreFoundation"
    "-framework CoreGraphics"
    "-framework CoreMedia"
    "-framework CoreText"
    "-framework CoreVideo"
    "-framework Foundation"
    "-framework OpenAL"
    "-framework OpenGL"
    "-framework QuartzCore"
    -lresolv
    )

=== src/layout/CMakeLists.txt ===
project(utoxLAYOUT LANGUAGES C)

add_library(utoxLAYOUT STATIC
    friend.c
    group.c
    notify.c
    settings.c
    sidebar.c
    userbadge.c
    background.c
    )

=== src/xlib/CMakeLists.txt ===
project(utoxNATIVE LANGUAGES C)

option(ENABLE_DBUS "Compile with dbus notification support" ON)


if(ENABLE_DBUS)
    find_package(DBus REQUIRED)
    include_directories(${DBUS_INCLUDE_DIRS})
    add_cflag("-DHAVE_DBUS=1")
endif()

#########################################
## Native Icon data
#########################################
add_custom_command(OUTPUT icon.o
    COMMAND cd ${uTox_SOURCE_DIR}/ && ld -r -b binary -o ${utoxNATIVE_BINARY_DIR}/icon.o icons/utox-128x128.png
    DEPENDS ../../icons/utox-128x128.png )
set_source_files_properties( icon.o PROPERTIES EXTERNAL_OBJECT true GENERATED true )
add_library(icon STATIC icon.o)
set_target_properties( icon PROPERTIES LINKER_LANGUAGE C )

#########################################
## Native Interface
#########################################
add_library(utoxNATIVE STATIC
    audio.c
    dbus.c
    dbus.h
    drawing.c
    event.c
    filesys.c
    freetype.c
    freetype.h
    gtk.c
    keysym2ucs.h
    main.c
    main.h
    mmenu.c
    mmenu.h
    screen_grab.c
    tray.c
    v4l.c
    video.c
    window.c

    ../posix/filesys.c
    )

find_package(Freetype REQUIRED)
include_directories(${FREETYPE_INCLUDE_DIRS})
message("Found Freetype version ${FREETYPE_VERSION_STRING}")
message("Freetype include: ${FREETYPE_INCLUDE_DIRS}")
message("Freetype library: ${FREETYPE_LIBRARIES}")

find_package(X11 REQUIRED)

message("X include:         ${X11_INCLUDE_DIR}")
message("X library:         ${X11_LIBRARIES}")
message("Xrender include:   ${X11_Xrender_INCLUDE_PATH}")
message("Xrender library:   ${X11_Xrender_LIB}")

if(ENABLE_DBUS AND DBUS_LIBRARIES)
    message("DBus include:  ${DBUS_INCLUDE_DIRS}")
    message("DBus library:  ${DBUS_LIBRARIES}")
else()
    set(DBUS_LIBRARIES "")
endif()

target_link_libraries(utoxNATIVE
        icon
        v4lconvert
        ${X11_LIBRARIES}
        ${X11_Xrender_LIB}
        fontconfig
        ${FREETYPE_LIBRARIES}
        )

if(LINUX OR NETBSD)
    target_link_libraries(utoxNATIVE
        resolv
        )
endif()

if(LINUX)
    target_link_libraries(utoxNATIVE
        dl
        ${DBUS_LIBRARIES}
        )
endif()

include(GNUInstallDirs)

install(FILES
    ../utox.desktop
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/applications"
    )

install(FILES
    ../utox.1
    DESTINATION "${CMAKE_INSTALL_MANDIR}/man1"
    )

install(FILES
   ../../icons/utox-14x14.png
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/14x14/apps"
    )

install(FILES
   ../../icons/utox-16x16.png
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/16x16/apps"
    )

install(FILES
   ../../icons/utox-22x22.png
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/22x22/apps"
    )

install(FILES
   ../../icons/utox-24x24.png
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/24x24/apps"
    )

install(FILES
   ../../icons/utox-32x32.png
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/32x32/apps"
    )

install(FILES
   ../../icons/utox-36x36.png
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/36x36/apps"
    )

install(FILES
   ../../icons/utox-48x48.png
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/48x48/apps"
    )

install(FILES
   ../../icons/utox-64x64.png
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/64x64/apps"
    )

install(FILES
   ../../icons/utox-72x72.png
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/72x72/apps"
    )

install(FILES
   ../../icons/utox-96x96.png
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/96x96/apps"
    )

install(FILES
   ../../icons/utox-128x128.png
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/128x128/apps"
    )

install(FILES
   ../../icons/utox-256x256.png
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/256x256/apps"
    )

install(FILES
   ../../icons/utox-512x512.png
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/512x512/apps"
    )

install(FILES
   ../../icons/utox.svg
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/scalable/apps"
    )

=== debian/changelog ===
utox (0.17.0-1) unstable; urgency=medium

  * Initial release (Closes: #770915)

 -- Yangfl <mmyangfl@gmail.com>  Fri, 30 Nov 2018 23:22:20 +0800

=== debian/control ===
Source: utox
Section: net
Priority: optional
Maintainer: Yangfl <mmyangfl@gmail.com>
Build-Depends:
 debhelper (>= 11~),
 cmake,
 check,
 libvpx-dev,
 libfontconfig1-dev,
 libdbus-1-dev,
 libv4l-dev,
 libxrender-dev,
 libopenal-dev,
 libxext-dev,
 libtoxcore-dev,
 libstb-dev,
 libminini-dev,
 libqrcodegen-dev,
Standards-Version: 4.2.1
Homepage: https://utox.io
Vcs-Git: https://salsa.debian.org/yangfl-guest/uTox.git
Vcs-Browser: https://salsa.debian.org/yangfl-guest/uTox

Package: utox
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: lightest and fluffiest Tox client
 µTox is the lightweight client with minimal dependencies; it not only looks
 pretty, it runs fast! µTox is available for Windows, OS X, and Linux (Android
 support is experimental), with full support for chat, file transfers,
 audio/video calling, and desktop sharing (both as video and inline
 screenshots). It also supports text group chats with audio groups pending the
 next Toxcore update.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1


export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CXXFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@

# disable link time optimizations if compiling takes too long
# -DENABLE_LTO=OFF
override_dh_auto_configure:
	dh_auto_configure -- \
		-DENABLE_ASAN=OFF \
		-DENABLE_FILTERAUDIO=OFF \
		-DENABLE_TESTS=ON

=== debian/tests/control ===
Tests: unittest.sh
Depends: @builddeps@

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%uTox-$1.tar.gz%,pgpsigurlmangle=s%archive/v(\d[\d.]*)\.tar\.gz%releases/download/v$1/uTox-v$1.endoffile.tar.gz.asc%" \
   https://github.com/uTox/uTox/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
